#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

#include "tsc.h"

void init_data(int *x, int size)
{
    int i;
    for (i=0; i<size; ++i)
       x[i]=i;        
}



int main(int argc, char *argv[])
{
    int i, j, n, c;
    double timerc, timecr;
    int *x;

    if (argc < 2) {
        fprintf(stderr, "Usage: %s <size>\n", argv[0]);
        return 1;
    }

    calibrate_tsc(0);
    
    n = atoi(argv[1]);
    
    c = 10000000;
    
    x = malloc(sizeof(int)*n*n);
    if (!x) {
        fprintf(stderr, "Memory allocation error\n");
        return 1;
    }
    
    init_data(x, n);

    #define X(R,C) (*(x+((R)*n)+(C)))
        
    start_timing(1);
    for (i=0; i<n; ++i)
        for (j=0; j<n; ++j)
            X(i,j) *= (i+j);          
    stop_timing(1);
    
    timerc = timing_result();
    
    start_timing(1);
    for (j=0; j<n; ++j)
        for (i=0; i<n; ++i)
            X(i,j) *= (i+j);          
    stop_timing(1);
    
    timecr = timing_result();
    
    fprintf(stderr, "n=%d, inner column=%.3f msec, inner row=%.3f msec\n", 
            n, timerc, timecr); 
 
    printf("%d %f %f\n", n, timerc, timecr);
    return 0;
}

