#ifndef __TSC_H__
#define __TSC_H__

#define __rdtscll(val) \
	__asm__ __volatile__("rdtsc" : "=A" (val))

#define __cli() __asm__ __volatile__("cli")
#define __sti() __asm__ __volatile__("sti")

extern void calibrate_tsc(int);

extern unsigned long long __t_start, __t_stop;

static inline void start_timing(int cli)
{
	if (cli)
		__cli();
	__rdtscll(__t_start);
}

static inline void stop_timing(int cli)
{
	__rdtscll(__t_stop);
	if (cli)
		__sti();
}

extern double timing_result(void);

extern unsigned long long cycle_result(void);

extern double cycles_to_time(unsigned long long);

#endif
